const uuid = require("uuid");
const SendChunkedMessage = require("../common/SendChunkedMessage");
const LogToConsole = require("../common/LogToConsole");
const MAX_BUFFER = 100000;

function sendFileOverWS(ws, data, logToConsole, callback) {
    var log = new LogToConsole(logToConsole, '[FILE]').log;
    var sendMessageService = new SendChunkedMessage(logToConsole);
    var fileInfo = {
        id: uuid.v4(),
        command: "fileSize",
        data: {
            size: data.byteLength
        }
    };

    fileInfo = JSON.stringify(fileInfo, null, "\t");
    sendMessageService.send(ws, fileInfo, function(err, result) {
        if (err) {
            log("**ERROR** An error occured while sending the size of the file");
            return callback(err);
        }
        else {
            log("File size sent", fileInfo);
            sendMessageService.send(ws, data, true, function(err, result) {
                if (err) return callback(err);
                if (result) return callback(null, result);
            });
        }
    });
}

module.exports = {
    sendFileOverWS: sendFileOverWS
};
